import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.AccuracyMeasure;
import org.shogun.BinaryLabels;
import org.shogun.CSVFile;
import org.shogun.LDA;
import org.shogun.RealFeatures;
import org.shogun.RealVector;

public class lda {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_binary_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_binary_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_binary_2d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/classifier_binary_2d_linear_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
BinaryLabels labels_train = new BinaryLabels(f_labels_train);
BinaryLabels labels_test = new BinaryLabels(f_labels_test);
//![create_features]

//![create_instance]
LDA lda = new LDA();
lda.set_features(features_train);
lda.set_labels(labels_train);
//![create_instance]

//![train_and_apply]
lda.train();
BinaryLabels labels_predict = lda.apply_binary(features_test);
//![train_and_apply]

//![extract_weights]
DoubleMatrix w = lda.get_w();
//![extract_weights]

//![evaluate_accuracy]
AccuracyMeasure eval = new AccuracyMeasure();
double accuracy = eval.evaluate(labels_predict, labels_test);
//![evaluate_accuracy]

//additional integration testing variables
DoubleMatrix output = labels_predict.get_labels();

}
}
