import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.AccuracyMeasure;
import org.shogun.BinaryLabels;
import org.shogun.CSVFile;
import org.shogun.LIBLINEAR_SOLVER_TYPE;
import org.shogun.LibLinear;
import org.shogun.RealFeatures;
import org.shogun.RealVector;

public class linear_svm {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_binary_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_binary_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_binary_2d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/classifier_binary_2d_linear_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
BinaryLabels labels_train = new BinaryLabels(f_labels_train);
BinaryLabels labels_test = new BinaryLabels(f_labels_test);
//![create_features]

//![set_parameters]
double C = 1.0;
double epsilon = 0.001;
//![set_parameters]

//![create_instance]
LibLinear svm = new LibLinear(C, features_train, labels_train);
svm.set_liblinear_solver_type(LIBLINEAR_SOLVER_TYPE.L2R_L2LOSS_SVC);
svm.set_epsilon(epsilon);
//![create_instance]

//![train_and_apply]
svm.train();
BinaryLabels labels_predict = svm.apply_binary(features_test);
//![train_and_apply]

//![extract_weights_bias]
DoubleMatrix w = svm.get_w();
double b = svm.get_bias();
//![extract_weights_bias]

//![evaluate_accuracy]
AccuracyMeasure eval = new AccuracyMeasure();
double accuracy = eval.evaluate(labels_predict, labels_test);
//![evaluate_accuracy]

// additional integration testing variables
DoubleMatrix output = labels_predict.get_labels();

}
}
