import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.CSVFile;
import org.shogun.EuclideanDistance;
import org.shogun.Hierarchical;
import org.shogun.IntMatrix;
import org.shogun.RealFeatures;
import org.shogun.RealVector;

public class hierarchical {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
//![create_features]

//![choose_distance]
EuclideanDistance distance = new EuclideanDistance(features_train, features_train);
//![choose_distance]

//![create_instance]
int merges = 3;
Hierarchical hierarchical = new Hierarchical(merges, distance);
//![create_instance]

//![train_model]
hierarchical.train();
//![train_model]

//![extract_results]
DoubleMatrix d = hierarchical.get_merge_distances();
DoubleMatrix cp = hierarchical.get_cluster_pairs();
//![extract_results]

}
}
