import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.CSVFile;
import org.shogun.Features;
import org.shogun.Math;
import org.shogun.RealFeatures;
import org.shogun.RealMatrix;
import org.shogun.SOBI;

public class ica_sobi {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats = new CSVFile("../../data/ica_2_sources.dat");

org.shogun.Math.init_random(1);

//![create_features]
RealFeatures features = new RealFeatures(f_feats);
//![create_features]

//![set_parameters]
SOBI ica = new SOBI();
ica.set_max_iter(200);
ica.set_tol(0.00001);
//![set_parameters]

//![apply_convert]
Features converted = ica.apply(features);
//![apply_convert]

//![extract]
DoubleMatrix mixing_matrix = ica.get_mixing_matrix();
RealFeatures casted = RealFeatures.obtain_from_generic(converted);
DoubleMatrix unmixed_signal = casted.get_feature_matrix();
//![extract]


}
}
