import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.CSVFile;
import org.shogun.MulticlassAccuracy;
import org.shogun.MulticlassLabels;
import org.shogun.MulticlassLogisticRegression;
import org.shogun.RealFeatures;
import org.shogun.RealVector;

public class multiclass_logisticregression {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/classifier_4class_2d_linear_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/classifier_4class_2d_linear_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/classifier_4class_2d_linear_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
MulticlassLabels labels_train = new MulticlassLabels(f_labels_train);
MulticlassLabels labels_test = new MulticlassLabels(f_labels_test);
//![create_features]


//![create_instance]
MulticlassLogisticRegression classifier = new MulticlassLogisticRegression(1, features_train, labels_train);
//![create_instance]

//![train_and_apply]
classifier.train();
MulticlassLabels labels_predict = classifier.apply_multiclass(features_test);
//![train_and_apply]

//![evaluate_accuracy]
MulticlassAccuracy eval = new MulticlassAccuracy();
double accuracy = eval.evaluate(labels_predict, labels_test);
//![evaluate_accuracy]

// integration testing variables
DoubleMatrix output = labels_predict.get_labels();

}
}
