import org.jblas.DoubleMatrix;
import org.jblas.FloatMatrix;

import org.shogun.shogun;
import org.shogun.CSVFile;
import org.shogun.GaussianKernel;
import org.shogun.KernelRidgeRegression;
import org.shogun.MeanSquaredError;
import org.shogun.RealFeatures;
import org.shogun.RealVector;
import org.shogun.RegressionLabels;

public class kernel_ridge_regression {
static {
System.loadLibrary("shogun");
}

public static void main(String argv[]) {
shogun.init_shogun_with_defaults();

CSVFile f_feats_train = new CSVFile("../../data/regression_1d_sinc_features_train.dat");
CSVFile f_feats_test = new CSVFile("../../data/regression_1d_sinc_features_test.dat");
CSVFile f_labels_train = new CSVFile("../../data/regression_1d_sinc_labels_train.dat");
CSVFile f_labels_test = new CSVFile("../../data/regression_1d_sinc_labels_test.dat");

//![create_features]
RealFeatures features_train = new RealFeatures(f_feats_train);
RealFeatures features_test = new RealFeatures(f_feats_test);
RegressionLabels labels_train = new RegressionLabels(f_labels_train);
RegressionLabels labels_test = new RegressionLabels(f_labels_test);
//![create_features]

//![create_appropriate_kernel]
double width = 1.0;
GaussianKernel kernel = new GaussianKernel(features_train, features_train, width);
//![create_appropriate_kernel]

//![create_instance]
double tau = 0.001;
KernelRidgeRegression krr = new KernelRidgeRegression(tau, kernel, labels_train);
//![create_instance]

//![train_and_apply]
krr.train();
RegressionLabels labels_predict = krr.apply_regression(features_test);
//![train_and_apply]

//![extract_alpha]
DoubleMatrix alpha = krr.get_alphas();
//![extract_alpha]

//![evaluate_error]
MeanSquaredError eval = new MeanSquaredError();
double mse = eval.evaluate(labels_predict, labels_test);
//![evaluate_error]

// integration testing variables
DoubleMatrix output = labels_test.get_labels();

}
}
